var bug667340 = {
  backup: null,

  init: function(){
    // xxx workaround Bug 667340
    this.backup = middleMousePaste;
    var func = middleMousePaste.toString();
    func = func.replace(
      / url = getShortcutOrURI\(clipboard.*\);/,
      <><![CDATA[
      $&
      // Don't risk messing up javascript on page (e.g. Google plus image thumbnails)
      var curCursor = getComputedStyle(event.target, "").cursor;
      if ((curCursor != 'auto') && (curCursor != 'default'))
        return;
      //
      let uriFixup = Cc["@mozilla.org/docshell/urifixup;1"]
                       .getService(Ci.nsIURIFixup);
      try {
        var uri = uriFixup.createFixupURI(url, uriFixup.FIXUP_FLAG_NONE);
      } catch (ex) {
        return;
      }
      if (!uri)
        return;
      url = uri.spec;
      ]]></>
    );
    middleMousePaste = new Function(
       func.match(/\((.*)\)\s*\{/)[1],
       func.replace(/^function\s*.*\s*\(.*\)\s*\{/, '').replace(/}$/, '')
    );

    window.addEventListener("unload", this, false);
  },

  uninit: function(){
    if (this.backup)
      middleMousePaste = this.backup;
    this.backup = null;

    window.removeEventListener("unload", this, false);
  },

  handleEvent: function(event) {
    switch(event.type){
      case "unload":
        this.uninit();
        break;
    }
  }
};
bug667340.init();
